#include "stdafx.h"


//void parameters::initialize(long size1D_x, long size1D_y, long size1D_z){

	void parameters::initialize(char* parameters_file1){



	long size_xi;
	long size_yi;
	long size_zi;
	float timestep_sizei;
	long timestep_numberi;
	float alphai;
	float betai;
	float Ci;
	float kappai;
	float k1i;
	float k2i;
	float k3i;
	float e1i;
	float e2i;
	float e3i;
	float ls_derivative_smoothingi;
	ifstream in_stream;
	in_stream.open(parameters_file1);

	in_stream >> size_xi ;
	in_stream >> size_yi ;
	in_stream >> size_zi ;
	in_stream >> timestep_sizei;
	in_stream >> timestep_numberi;
	in_stream >> alphai;
	in_stream >> betai;
	in_stream >> Ci;
	in_stream >> kappai;
	in_stream >> k1i;
	in_stream >> k2i;
	in_stream >> k3i;
	in_stream >> e1i;
	in_stream >> e2i;
	in_stream >> e3i;
	in_stream >> ls_derivative_smoothingi;
	in_stream.close();


	size1D_x = size_xi;
	size1D_y = size_yi;
	size1D_z = size_zi;


	for(short m=0;m<5;m++){

		nodes_number_old[m]=0;
		tets_number_old[m]=0;
		nodes_number_new[m]=0;
		tets_number_new[m]=0;

	}

	for(short m=0;m<4;m++){

		nodes_tbd_number_old[m]=0;
		nodes_tbd_number_new[m]=0;

	}


	if( (size1D_x % 2) == 1 ){
		size1D_x = size1D_x + 1;
	}
	if( (size1D_x % 4) == 2 ){
		size1D_x = size1D_x + 2;
	}

	if( (size1D_y % 2) == 1 ){
		size1D_y = size1D_y + 1;
	}
	if( (size1D_y % 4) == 2 ){
		size1D_y = size1D_y + 2;
	}

	if( (size1D_z % 2) == 1 ){
		size1D_z = size1D_z + 1;
	}
	if( (size1D_z % 4) == 2 ){
		size1D_z = size1D_z + 2;
	}


		size1D_xl=(size1D_x+16)*2;
	size1D_yl=(size1D_y+16)*2;
	size1D_zl=(size1D_z+16)*2;
	size3Dl = (size1D_xl*size1D_yl*size1D_zl)*8;

	size1D_xl_z2=(size1D_x/2+16)*2;
	size1D_yl_z2=(size1D_y/2+16)*2;
	size1D_zl_z2=(size1D_z/2+16)*2;
	size3Dl_z2 = (size1D_xl_z2*size1D_yl_z2*size1D_zl_z2)*8;

	size1D_xl_z3=(size1D_x/4+16)*2;
	size1D_yl_z3=(size1D_y/4+16)*2;
	size1D_zl_z3=(size1D_z/4+16)*2;
	size3Dl_z3 = (size1D_xl_z3*size1D_yl_z3*size1D_zl_z3)*8;

	max_number_of_regions=0;

}