#include "parameters.h"

// 'node' is a class.  it knows the x y and z coordinates of a node by pointing to a row of nodes_array.
// unlike the nodes array it also has information about what tets the node is in, what edges etc.  


class node{
	public:

	long *node_number;
	float *x, *y, *z ;

	//creating the mesh requires both creating and removing.  'removed' is either true or false, which indicates
	//whether this class memeber should be included in the final mesh

	bool removed;


	//for finding the edges and the faces, the edges and faces that this node is in is kept track of

	//long edge_belong_number;
	//long face_belong_number;
	short edge_belong_entered;
	short face_belong_entered;
	long **edge_belong;
	long **face_belong;

	//can be in up to 4 hexas
	long hexa_belong[8];

	long diag_bdry_share[8];
	//long hexa_belong_previous[8];


	void set_edge_belong_number0 ();
	void set_face_belong_number0 ();
	void edge_belong_number_p1 ();
	void face_belong_number_p1 ();
	void add_edge_belong (long *ptr_to_edge_number);
	void add_face_belong (long *ptr_to_face_number);
	//void set_edge_belong_size();
	//void set_face_belong_size();




	void set_remove_false();

	void set_remove_true();

	
	void initialize_node1 (long node_number_input, float x_coordinate_array_grid1[], float y_coordinate_array_grid1[], float z_coordinate_array_grid1[], long node_array_grid1[]);
	void initialize_node2 (long node_number_input, float x_coordinate_array_grid2[], float y_coordinate_array_grid2[], float z_coordinate_array_grid2[], long node_array_grid2[],parameters &param);

	void new_node(long this_node_number, long new_node_array[], float new_x_coordinate_array[], float new_y_coordinate_array[], float new_z_coordinate_array[]);

	void empty_hexa();

	void add_hexa(long hexa_number);


};