#include "perform_front_propagation_3d.h"
#include "fib.h"
#include "fibpriv.h"
#include "iostream"
#include "fstream"
#include "iomanip"

#include"parameters.h"
using namespace std;


///////////////////////////////////////////
/*********************************************
change parameters here
***********************************************/


//void parameters::initialize_parameters(char *filename_region1,char *filename_level_set1, int sx, int sy, int sz, char *filename_region_output1, int zoom_level1, int compute_ls1){

void parameters::initialize_parameters(char *region_file_in1, char *parameters_file1 ,char *region_file_out1, char *ls_file_out1){


	long size_xi;
	long size_yi;
	long size_zi;
	float timestep_sizei;
	long timestep_numberi;
	float alphai;
	float betai;
	float Ci;
	float kappai;
	float k1i;
	float k2i;
	float k3i;
	float e1i;
	float e2i;
	float e3i;
	float ls_derivative_smoothingi;
	ifstream in_stream;
	in_stream.open(parameters_file1);

	in_stream >> size_xi ;
	in_stream >> size_yi ;
	in_stream >> size_zi ;
	in_stream >> timestep_sizei;
	in_stream >> timestep_numberi;
	in_stream >> alphai;
	in_stream >> betai;
	in_stream >> Ci;
	in_stream >> kappai;
	in_stream >> k1i;
	in_stream >> k2i;
	in_stream >> k3i;
	in_stream >> e1i;
	in_stream >> e2i;
	in_stream >> e3i;
	in_stream >> ls_derivative_smoothingi;
	in_stream.close();





	strcpy(region_file_in, region_file_in1);//"sphere_4r_region.txt" );
	strcpy(region_file_out, region_file_out1);
	strcpy(filename_one_region, "region_01_102_v2.txt" );
	strcpy(ls_file_out, ls_file_out1);//"sphere_4r_ls.txt" );
       // std::cout<<ls_file_out<<std::endl;

	//zoom_level = zoom_level1;
	zoom_level = 1;


	//if(compute_ls1 == 1){
	compute_ls = true;
	//}else{
	//	compute_ls = false;
	//}
	
	


	single_region = 102;


	size1D_x = size_xi;//sx;//40;
	size1D_y = size_yi;//sy;//40;
	size1D_z = size_zi;//sz;//40;


	size3D = size1D_x*size1D_y*size1D_z;

	//you can specify the volume below.  this is useful when you want to look at one region in the brain
	// in two different images.  let the program find the min's and max's for one image and then specify
	//it to be the same for the second image

	specify_min_max = false;
	x_min = 76;
	x_max = 152;
	y_min = 94;
	y_max = 195;
	z_min = 97;
	z_max = 186;


	sphere = false;
	one_region = false;

}


void parameters::change_size(long size1D_x_input, long size1D_y_input, long size1D_z_input){

	size1D_x = size1D_x_input;
	size1D_y = size1D_y_input;
	size1D_z = size1D_z_input;

	size3D = size1D_x_input*size1D_y_input*size1D_z_input;

}
