#include "perform_front_propagation_3d.h"
#include "fib.h"
#include "fibpriv.h"
#include "iostream"
#include "fstream"
#include "iomanip"

#include"parameters.h"
using namespace std;


//note that the radius of the sphere is set at 20


void sphere(short regions_array[], parameters param){

	double sphere_radius = 10;
	double x_center = floor(param.size1D_x/2.0)+4;
	double y_center = floor(param.size1D_y/2.0)+4;
	double z_center = floor(param.size1D_z/2.0)+4;

	
	for(long kk=0; kk<(param.size1D_z);kk++){
	for(long jj=0; jj<(param.size1D_y);jj++){
	for(long ii=0; ii<(param.size1D_x);ii++){

		if( (ii-x_center)*(ii-x_center) + (jj-y_center)*(jj-y_center) + (kk-z_center)*(kk-z_center) < sphere_radius*sphere_radius ){
			if( (jj>=y_center) && (ii>=x_center) ){
				regions_array_(ii,jj,kk) = 1;
			}
			if( (jj>=y_center) && (ii<=x_center) ){
				regions_array_(ii,jj,kk) = 2;
			}
			if( (jj<=y_center) && (ii>=x_center) ){
				regions_array_(ii,jj,kk) = 3;
			}
			if( (jj<=y_center) && (ii<=x_center) ){
				regions_array_(ii,jj,kk) = 4;
			}

		}else{
			regions_array_(ii,jj,kk) = 0;
		};

	};
	};
	};

	ofstream out_stream;

	out_stream.open(param.region_file_in);

for(long zz=0;zz<param.size3D;zz++){

	out_stream << regions_array[zz] << " " ;
};

out_stream.close();


cout << "sphere region printed" << endl;



};
			
