// make_parameters.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


int main( int argc, char *argv[])
{

	if( argc < 16 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " size_file resolution_file timestep_size timestep_number alpha beta C Kappa k1 k2 k3 e1 e2 e3 ls_derivative_smoothing parameters " << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }

	

	long size_x;
	long size_y;
	long size_z;

	float res_x;
	float res_y;
	float res_z;

	ifstream in_stream;

	in_stream.open(argv[1]);

	in_stream >> size_x ;
	in_stream >> size_y ;
	in_stream >> size_z ;

	in_stream.close();

	in_stream.open(argv[2]);

	in_stream >> res_x ;
	in_stream >> res_y ;
	in_stream >> res_z ;

	in_stream.close();

	float timestep_size;
	timestep_size = float(std::atof(argv[3]));

	long timestep_number;
	timestep_number = std::atoi(argv[4]);

	float alpha;
	alpha = float(std::atof(argv[5]));

	float beta;
	beta = float(std::atof(argv[6]));

	float C;
	C = float(std::atof(argv[7]));

	float Kappa;
	Kappa = float(std::atof(argv[8]));

	float k1;
	k1 = float(std::atof(argv[9]));

	float k2;
	k2 = float(std::atof(argv[10]));

	float k3;
	k3 = float(std::atof(argv[11]));

	float e1;
	e1 = float(std::atof(argv[12]));

	float e2;
	e2 = float(std::atof(argv[13]));

	float e3;
	e3 = float(std::atof(argv[14]));

	float ls_derivative_smoothing;
	ls_derivative_smoothing = float(std::atof(argv[15]));


	ofstream out_stream;

	out_stream.open(argv[16]);

	out_stream << size_x << " ";
	out_stream << size_y << " ";
	out_stream << size_z << " ";
	out_stream << timestep_size << " ";
	out_stream << timestep_number << " ";
	out_stream << alpha << " ";
	out_stream << beta << " ";
	out_stream << C << " ";
	out_stream << Kappa << " ";
	out_stream << k1 << " ";
	out_stream << k2 << " ";
	out_stream << k3 << " ";
	out_stream << e1 << " ";
	out_stream << e2 << " ";
	out_stream << e3 << " ";
	out_stream << ls_derivative_smoothing << " ";
	out_stream << res_x << " ";
	out_stream << res_y << " ";
	out_stream << res_z << " ";



	return 0;
}

