#include "stdafx.h"







void node_info::set_size_to_0 (){

	number_of_regions_belong = 0;


}

void node_info::add_region (short region_added){

	if(number_of_regions_belong == 0){

		regions_belong = new short[1];

		regions_belong[0] = region_added;

		number_of_regions_belong = number_of_regions_belong + 1;

	}else{


		//making sure region isn't already there

		bool already_there = false;

		for(short n=0; n<number_of_regions_belong; n++){

			if(region_added == regions_belong[n]){

				already_there = true;

			}
		}

		//adding the new region onto the end

		if(already_there == false){

			short *temp; temp = new short[number_of_regions_belong+1];

			for(short n=0; n<number_of_regions_belong; n++){

				temp[n] = regions_belong[n];

			}

			temp[number_of_regions_belong] = region_added;

			delete [] regions_belong;

			number_of_regions_belong = number_of_regions_belong + 1;

			regions_belong = new short[number_of_regions_belong];

			for(short n=0; n<number_of_regions_belong; n++){

				regions_belong[n] = temp[n];

			}

			delete [] temp;

		}

	}

}

void node_info::set_vec_sizes(){

	vec_x = new float[number_of_regions_belong];
	vec_y = new float[number_of_regions_belong];
	vec_z = new float[number_of_regions_belong];



}

void node_info::set_vector (short region_number, float vec_x_input, float vec_y_input, float vec_z_input){

	for(short n=0;n<number_of_regions_belong;n++){

		if(regions_belong[n] == region_number){

			vec_x[n] = vec_x_input;
			vec_y[n] = vec_y_input;
			vec_z[n] = vec_z_input;

		}

	}


}

void node_info::set_current_voxel_region(short region_input){

	current_voxel_region = region_input;

}

void node_info::set_associated_node_volumes_size(){

	associated_node_volumes = new float[number_of_regions_belong];
	associated_node_volumes_ext = new float[number_of_regions_belong];
	associated_node_volumes_ext_tot = new float[number_of_regions_belong];
	associated_node_volumes_ext2 = new float[number_of_regions_belong];
	associated_node_volumes_ext2_tot = new float[number_of_regions_belong];
	//vec_x_ext = new float[number_of_regions_belong];
	//vec_y_ext = new float[number_of_regions_belong];
	//vec_z_ext = new float[number_of_regions_belong];
	//vec_x_ext2 = new float[number_of_regions_belong];
	//vec_y_ext2 = new float[number_of_regions_belong];
	//vec_z_ext2 = new float[number_of_regions_belong];


	for(short n=0;n<number_of_regions_belong;n++){
		associated_node_volumes[n] = 0.0;
		associated_node_volumes_ext[n] = 0.0;
		associated_node_volumes_ext_tot[n] = 0.0;
		associated_node_volumes_ext2[n] = 0.0;
		associated_node_volumes_ext2_tot[n] = 0.0;
		//vec_x_ext[n] = 0.0;
		//vec_y_ext[n] = 0.0;
		//vec_z_ext[n] = 0.0;
		//vec_x_ext2[n] = 0.0;
		//vec_y_ext2[n] = 0.0;
		//vec_z_ext2[n] = 0.0;
	}


}

/*
void node_info::set_associated_node_areas_size(){

	associated_node_areas = new float[number_of_regions_belong];

	for(short n=0;n<number_of_regions_belong;n++){
		associated_node_areas[n] = 0.0;
	}


}
*/


void node_info::set_associated_node_volumes_to_0(){

	for(short n=0;n<number_of_regions_belong;n++){
		associated_node_volumes[n] = 0.0;
		associated_node_volumes_ext[n] = 0.0;
		associated_node_volumes_ext_tot[n] = 0.0;
		associated_node_volumes_ext2[n] = 0.0;
		associated_node_volumes_ext2_tot[n] = 0.0;
		//vec_x_ext[n] = 0.0;
		//vec_y_ext[n] = 0.0;
		//vec_z_ext[n] = 0.0;
		//vec_x_ext2[n] = 0.0;
		//vec_y_ext2[n] = 0.0;
		//vec_z_ext2[n] = 0.0;
	}

}
/*
void node_info::set_associated_node_areas_to_0(){

	for(short n=0;n<number_of_regions_belong;n++){
		associated_node_areas[n] = 0.0;
	}

}
*/


void node_info::add_associated_node_volumes(short region_position, float volume){

	associated_node_volumes[region_position] = associated_node_volumes[region_position]+volume;

	//cout << volume << endl;

}

/*
void node_info::add_associated_node_volumes_ext(short region_position, float volume, long other_node_number){

	bool hit;
	hit = false;

	for(short m=0;m<30;m++){
		if(hit_list[m] == other_node_number){
			hit = true;
		}
	}

	if(hit==false){
		associated_node_volumes_ext[region_position] = associated_node_volumes_ext[region_position]+volume;
		
	}

	//cout << volume << endl;

}

void node_info::add_associated_node_volumes_ext_tot(short region_position, float volume, long other_node_number){

	bool hit;
	hit = false;

	for(short m=0;m<30;m++){
		if(hit_list[m] == other_node_number){
			hit = true;
		}
	}

	if(hit==false){
		associated_node_volumes_ext_tot[region_position] = associated_node_volumes_ext_tot[region_position]+volume;
		
		for(short m=0;m<30;m++){
			if(hit_list[m] == -1){
				hit_list[m] = other_node_number;
				break;
			}
		}



	}

	//cout << volume << endl;

}
*/

/*
void node_info::add_associated_node_areas(short region_position, float area){

	associated_node_areas[region_position] = associated_node_areas[region_position]+area;

	//cout << area << endl;

}
*/

void node_info::set_ls_size(){

	ls_val = new float[number_of_regions_belong];
	grad2_val = new float[number_of_regions_belong];
	grad2_bdry_val = new float[number_of_regions_belong];
//	biharm_val = new float[number_of_regions_belong];
//	biharm_bdry_val = new float[number_of_regions_belong];

}



void node_info::set_ls (short region_position, float ls_val_input){

			ls_val[region_position] = ls_val_input;

}

void node_info::set_grad2 (short region_position, float grad2_val_input){

			grad2_val[region_position] = grad2_val_input;

}

/*
void node_info::set_biharm (short region_position, float biharm_val_input){

			biharm_val[region_position] = biharm_val_input;

}
*/

void node_info::add_to_grad2( float add_input, short region_position){

	grad2_val[region_position] = grad2_val[region_position]+add_input;

}

/*

void node_info::add_to_biharm( float add_input, short region_position){

	biharm_val[region_position] = biharm_val[region_position]+add_input;

}
*/

void node_info::add_to_grad2_bdry( float add_input, short region_position){

	grad2_bdry_val[region_position] = grad2_bdry_val[region_position]+add_input;

}

/*
void node_info::add_to_biharm_bdry( float add_input, short region_position){

	biharm_bdry_val[region_position] = biharm_bdry_val[region_position]+add_input;

}
*/



void node_info::add_to_vec (float add_input_x, float add_input_y, float add_input_z, short region_position){



		vec_x[region_position] = vec_x[region_position]+add_input_x;
		vec_y[region_position] = vec_y[region_position]+add_input_y;
		vec_z[region_position] = vec_z[region_position]+add_input_z;

}


void node_info::set_vecs_to_0(){

	for(short n=0;n<number_of_regions_belong;n++){
		vec_x[n] = 0;
		vec_y[n] = 0;
		vec_z[n] = 0;
 
	}

}

void node_info::set_grad2_to_0(){

	for(short n=0;n<number_of_regions_belong;n++){
		grad2_val[n] = 0;
		grad2_bdry_val[n] = 0;
 
	}

}

/*
void node_info::set_biharm_to_0(){

	for(short n=0;n<number_of_regions_belong;n++){
		biharm_val[n] = 0;
		biharm_bdry_val[n] = 0;
 
	}

}
*/




